--	UniTarget by Unique of the Lightning Troopers guild on Dalaran, Murduck of Lemmings of the Light on EU-Aszune and Murduck of The Old Guard on EU-Bronze Dragonflight
--	Thanks to Meog, Jooky, Norganna, Sardonic, Woolfeist, Trentin, Zuban, Lemine, Kaitlin & Dizzarian
--      whose code I've blatantly ripped in parts and learnt a lot from :).


UNITARGETVERSION = GetAddOnMetadata("UniTarget","Version");
UNITARGETNAME = "UniTarget";
UNITARGETDESC = "UniTarget mod to allow keybind for target info";
UNITARGETFRAME = "UniTarget_Frame";
BINDING_HEADER_UNITARGET = "Uni Target";

UniTarget_NameRegistered = 0;
UniTarget_Message = 0;

local UniTarget_Lang="Common";
local GetPlayerMapPosition = C_Map.GetPlayerMapPosition
local myfaction=UnitFactionGroup("player");
if (UnitFactionGroup("player")=="Horde") then
	UniTarget_Lang="Orcish";
end

------------------------------------------------------------------------------------------------
-- Message Construction
------------------------------------------------------------------------------------------------

function UniTarget_SetupMessage()
	--SetMapToCurrentZone();
	if (UnitName("target") ~= "Unknown") and (UnitName("target") ~= nil) then
		local UniTarHealth = UnitHealth("target");
		local UniTarName = UnitName("target");
		local UniTarColName = UnitName("target");
		local UniTarLvl = 0;
		local UniTarClass = UnitClass("target");
		local UniTarRace = 0;
		local UniTarPVPName = 0;
		local UniTarGuild = GetGuildInfo("target");
		local UniTarLocationMsg = "";
		--local UniTarLocationX,UniTarLocationY = GetPlayerMapPosition(uiMapID, "player");
		--if ( UnitIsPlayer("target") ~= nil) then
		--	if (UnitName("target") == UnitName("player")) or (UnitInParty("target")) or (UnitInRaid("target")) then
		--	UniTarLocationX,UniTarLocationY = GetPlayerMapPosition(uiMapID, "target");
		--	end
		--end
		local UniTarPVPTagMsg = "";
		local UniSubZone=GetSubZoneText();
		local UniMainZone=GetZoneText();
		--UniTarLocationX=floor(UniTarLocationX*100);
		--UniTarLocationY=floor(UniTarLocationY*100);
		local LocMsg = "";
		--if (UniTarLocationX==0 and UniTarLocationY==0) then
		--	UniTarLocationMsg = format("unknown loc in"..UniSubZone);
		--else
		--	if (strlen(UniSubZone) > 1) then
		--		UniTarLocationMsg = format("("..UniTarLocationX..","..UniTarLocationY..") in "..UniSubZone);
		--	else
		--		UniTarLocationMsg = format("("..UniTarLocationX..","..UniTarLocationY..") in "..UniMainZone);
		--	end
		--end
		UniTarLocationMsg = format("in "..UniSubZone.." in "..UniMainZone);

		if ( UnitLevel("target") == -1 ) then
			UniTarLvl = "??";
		else
			UniTarLvl = UnitLevel("target");
		end
		if ( UnitClassification("target") == "elite") then
			UniTarLvl = format(UniTarLvl.."(E)");
		elseif ( UnitClassification("target") == "rareelite") then
			UniTarLvl = format(UniTarLvl.."(E+)");
		elseif ( UnitClassification("target") == "rare") then
			UniTarLvl = format(UniTarLvl.."(R)");
		end
		if (UnitHealthMax("target") ~= 100) then
			UniTarHealth = floor(100*UnitHealth("target")/UnitHealthMax("target"));
		end
		-- if (UnitIsPVP("target")) then
		-- 	UniTarPVPTagMsg = "[PvP: ON]";
		-- else
		-- 	UniTarPVPTagMsg = "[PvP: OFF]";
		-- end
		
		-- Constructing the message (style 1 = verbose, style 2 = brief)
		UniTarget_Message = "Target: ";
		UniTarget_Message = UniTarget_Message..UniTarName;
		if ( GetGuildInfo("target") ~= nil ) then
			UniTarget_Message = UniTarget_Message.." <"..GetGuildInfo("target")..">";
		end
		UniTarget_Message = UniTarget_Message.." L"..UniTarLvl;
--		if (UnitRace("target") ~= nil ) then
--			UniTarget_Message = UniTarget_Message.." "..UniTarRace;
--		end
--		UniTarget_Message = UniTarget_Message.." "..UniTarClass;
		UniTarget_Message = UniTarget_Message.." "..UniTarHealth.."%";
--		UniTarget_Message = UniTarget_Message.." "..UniTarLocationMsg;
--		UniTarget_Message = UniTarget_Message.." "..UniTarPVPTagMsg;
		if UnitExists("Raid1") then
			local raidCount = 0
			local deadCount = 0
			local raidID, percent
			local UniAlive = 0
	
			-- Init Alive Bar
			for num=1,40 do
				raidID = "raid"..num
				if UnitExists(raidID) and UnitIsConnected(raidID) then
					raidCount = raidCount +1
					if UnitIsDead(raidID) or UnitIsGhost(raidID) then
						deadCount = deadCount + 1 
					end 
				end
			end
			percent = floor(((raidCount-deadCount)/raidCount)*100)
			UniAlive = raidCount - deadCount
			
			UniTarget_Message = UniTarget_Message..", "..UniAlive.."/"..raidCount.." still alive ("..percent.."% of the raid)";
		elseif (UnitExists("Party1")) then
			local partyCount = 1
			local deadCount = 0
			local partyID, percent
			local UniAlive = 0
				for num=1,5 do
				partyID = "Party"..num
				if UnitExists(partyID) and UnitIsConnected(partyID) then
					partyCount = partyCount +1
					if UnitIsDead(partyID) or UnitIsGhost(partyID) then
						deadCount = deadCount + 1
					end
				end
			end
			percent = floor(((partyCount-deadCount)/partyCount)*100)
			UniAlive = partyCount - deadCount
			UniTarget_Message = UniTarget_Message..", "..UniAlive.."/"..partyCount.." still alive ("..percent.."% of the party)";
		end
	end
end


------------------------------------------------------------------------------------------------
-- Message-processing function to make my life easier :P
------------------------------------------------------------------------------------------------

function UniTarget_ChannelMessage(message, channel)
	SendChatMessage(message, channel);
end

function UniTarget_ChatPrint(str)
	if ( DEFAULT_CHAT_FRAME ) then 
		DEFAULT_CHAT_FRAME:AddMessage(str, 1.0, 0.5, 0.25);
	end
end

------------------------------------------------------------------------------------------------
-- Keybind Text
------------------------------------------------------------------------------------------------

function UniTarget_OnKeypressOne()	-- Party keybind
	if (UnitName("target") ~= "Unknown") and (UnitName("target") ~= nil) then
		UniTarget_SetupMessage();
		UniTarget_ChannelMessage(UniTarget_Message, PARTY);
	end
end

function UniTarget_OnKeypressTwo()	-- Guild keybind
	if (UnitName("target") ~= "Unknown") and (UnitName("target") ~= nil) then
		UniTarget_SetupMessage();
		UniTarget_ChannelMessage(UniTarget_Message, GUILD);
	end
end

function UniTarget_OnKeypressThree()	-- Officer keybind
	if (UnitName("target") ~= "Unknown") and (UnitName("target") ~= nil) then
		UniTarget_SetupMessage();
		UniTarget_ChannelMessage(UniTarget_Message, "OFFICER");
	end
end

function UniTarget_OnKeypressFour()	-- Self keybind
	if (UnitName("target") ~= "Unknown") and (UnitName("target") ~= nil) then
		UniTarget_SetupMessage();
		UniTarget_ChatPrint(UniTarget_Message);
	end
end

function UniTarget_OnKeypressFive()	-- Raid keybind
	if (UnitName("target") ~= "Unknown") and (UnitName("target") ~= nil) then
		UniTarget_SetupMessage();
		UniTarget_ChannelMessage(UniTarget_Message, RAID);
	end
end